// Copyright 1999, The Wilson Partnership.
// All Rights Reserved.
// @(#)SimpleSntpdImpl.java, 0.1, 13 September 1999
// Author: John Wilson - tug@wilson.co.uk

package uk.co.wilson.tini.rfc2030;

import uk.co.wilson.tini.util.Clock;

public final class SimpleSntpdImpl extends SntpdImpl {
	public SimpleSntpdImpl() {
		super(new MessageProcessor());
	}
	
	private static class MessageProcessor extends SntpMessageProcessor.Impl {
		public MessageProcessor() {
			super((byte)1,
						(byte)-10,
						new byte[] {0, 0, 0, 0},
						new byte[] {0, 0, 0, 0},
						new byte[] {(byte)'L', (byte)'O', (byte)'C', (byte)'L'});
			
			clockSynchronized = true;
		}
		
		protected void setSourceTime(final SntpMessage message) {
			// TODO set the system clock from this message
		}
		
		protected Timestamp getTimestamp() {
			return new Timestamp(referenceTimestamp, getTime());
		}
		
		private byte[] getTime() {
		final byte[] stamp = new byte[8];
		final int time[] = clock.getRFC2030TickCount64();
		
		//
		// TODO the milliscond half of the time need to have the ls 22 bits
		//			set to a random bit pattern
		//			Do this when Tini supports java.util.Random
		//
		
			setHalf(time[0], stamp, 0);
			setHalf(time[1], stamp, 4);

			return stamp;
		}
		
		private static void setHalf(final int value, final byte[] stamp, final int i) {
			stamp[i] = (byte)(value >> 24);
			stamp[i + 1] = (byte)(value >> 16);
			stamp[i + 2] = (byte)(value >> 8);
			stamp[i + 3] = (byte)value;
		}
															 
		private final Clock clock = new Clock();
		private byte[] referenceTimestamp = getTime();
	}
	
	public static final Thread instance = new SimpleSntpdImpl();
}
