// Copyright 1999, The Wilson Partnership.
// All Rights Reserved.
// @(#)TimedImpl.java, 0.1, 13 September 1999
// Author: John Wilson - tug@wilson.co.uk

package uk.co.wilson.tini.rfc868;

import java.net.Socket;

import java.io.IOException;

import uk.co.wilson.tini.util.TCPDaemonImpl;
import uk.co.wilson.tini.util.UDPDaemonImpl;
import uk.co.wilson.tini.util.UDPMessage;
import uk.co.wilson.tini.util.Clock;

public final class TimedImpl {
	private TimedImpl() {
	}
	
	public final static class TCP extends TCPDaemonImpl {
		private TCP() {
			super(port);
		}
		
		protected void respond(final Socket socket) throws IOException {
			socket.getOutputStream().write(clock.getTime());
		}
		
		public static final Thread instance = new TCP();
	
		private final TimeClock clock = new TimeClock();
		
		private static final int port = 37;
	}

	public final static class UDP extends UDPDaemonImpl {
		private UDP() {
			super(port, new UDPMessage.Impl(0) {
												public boolean setResponse() {
													packet.setData(clock.getTime());
													packet.setLength(packet.getData().length);
													
													return true;
												}
			
												private final TimeClock clock = new TimeClock();
										});
		}
		
		public static final Thread instance = new UDP();
	
		private static final int port = 37;
	}
	
	private final static class TimeClock extends Clock {
		public byte[] getTime() {
		final int time = getRFC868TickCount32();
	
			return new byte[] {(byte)(time >> 24), (byte)(time >> 16), (byte)(time >> 8), (byte)time};
		}
	}
}
