package uk.co.wilson.tini.util;

public class Clock extends com.dalsemi.system.Clock {
	public int[] getRFC2030TickCount64() {
        getRTC();

        return new int[] {getDateInSeconds(), getThousandths()};
	}
		
	public int getRFC868TickCount32() {
        getRTC();

        return getDateInSeconds();
	}

    public int getHour24() {
        return is12Hour ? hour + 12 : hour;
    }

    private int getDateInSeconds() {
        final int years = getY2KYear();
 //        final int days = years * 365 + (years / 4) + monthDays[month] + date - 1;
        final int daysSoFar;
        switch (month) {
            case  1: daysSoFar = 0;
                     break;
            case  2: daysSoFar = 31;
                     break;
            case  3: daysSoFar = 59;
                     break;
            case  4: daysSoFar = 90;
                     break;
            case  5: daysSoFar = 120;
                     break;
            case  6: daysSoFar = 151;
                     break;
            case  7: daysSoFar = 181;
                     break;
            case  8: daysSoFar = 212;
                     break;
            case  9: daysSoFar = 243;
                     break;
            case 10: daysSoFar = 273;
                     break;
            case 11: daysSoFar = 304;
                     break;
            default: daysSoFar = 334;
        }
        final int days = years * 365 + (years / 4) + daysSoFar + date - 1;
        final int hours = days * 24 + getHour24() - 1;
        final int minutes = hours * 60 + minute;

        return minutes * 60 + second;
    }

    private int getThousandths() {
        return hundredth * 10 * ONE_THOUSANDTH;
    }

    private int getY2KYear() {
        return (year < 70) ? year + 100 : year;
    }
		
	private static final int ONE_THOUSANDTH = 0X00418937;	// 0.001 as a binary fraction	
	private static final int[] monthDays = {0, 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334};
}
