// Copyright 1999, The Wilson Partnership.
// All Rights Reserved.
// @(#)TCPDaemonImpl.java, 0.1, 13 September 1999
// Author: John Wilson - tug@wilson.co.uk

package uk.co.wilson.tini.util;

import java.net.ServerSocket;
import java.net.Socket;

import java.io.IOException;

public abstract class TCPDaemonImpl extends DaemonImpl {
	public TCPDaemonImpl(final int socketNumber) {
		socket = getSocket(socketNumber);
	}
	
	protected void doTransaction() throws IOException {
	final Socket s = socket.accept();
	
		try {
			respond(s);
		}
		finally {
			s.close();
		}
	}
	
	protected abstract void respond(Socket socket) throws IOException;

	private static ServerSocket getSocket(final int socketNumber) {
		try {
			return new ServerSocket(socketNumber);
		}
		catch (final IOException e) {
			return null;
		}
	}
	
	protected final ServerSocket socket;

}
