// Copyright 1999, The Wilson Partnership.
// All Rights Reserved.
// @(#)UDPDaemonImpl.java, 0.1, 13 September 1999
// Author: John Wilson - tug@wilson.co.uk

package uk.co.wilson.tini.util;

import java.net.DatagramSocket;

import java.io.IOException;

public abstract class UDPDaemonImpl extends DaemonImpl {
	public UDPDaemonImpl(final int socketNumber, final UDPMessage message) {
		this.message = message;
		this.socket = makeSocket(socketNumber);
		
		try {
			if (socket != null) setSocketOptions();
		}
		catch (final IOException e) {
		}
	}
	
	protected void setSocketOptions() throws IOException {
		// override if you want to change the standard socket settings
	}
		
	protected void doTransaction() throws IOException {
		socket.receive(message.getPacket());
					
		if (message.setResponse())
			socket.send(message.getPacket());
	}
	
	private static DatagramSocket makeSocket(final int socketNumber) {
		try {
			return new DatagramSocket(socketNumber);
		}
		catch (final IOException e) {
			return null;
		}
	}
	
	protected final UDPMessage message;
	protected final DatagramSocket socket;
}
