// Copyright 1999, The Wilson Partnership.
// All Rights Reserved.
// @(#)UDPMessage.java, 0.1, 14 September 1999
// Author: John Wilson - tug@wilson.co.uk

package uk.co.wilson.tini.util;

import java.net.DatagramPacket;

public interface UDPMessage {
	DatagramPacket getPacket();
	boolean setResponse();

	abstract class Impl implements UDPMessage {
	public Impl(final int length) {
			message = new byte[length];
			packet = new DatagramPacket(message, message.length);
		}
		
		public DatagramPacket getPacket() {
			return packet;
		}
	
		protected static void moveBytes(final byte[] dest, final byte[] src, final int s) {
			System.arraycopy(src, s, dest, 0, dest.length);
		}
		
		protected static void moveBytes(final byte[] dest, final int d, final byte[] src) {
			System.arraycopy(src, 0, dest, d, src.length);
		}
		
		private static void moveBytes(final byte[] dest, int d, final byte[] src, int s, int len) {
			System.arraycopy(src, s, dest, d, len);
		}
		
		protected final DatagramPacket packet;
		protected final byte[] message ;
	}
}
